﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.UltraChart.Resources.Appearance;
using Infragistics.UltraChart.Shared.Styles;
using Infragistics.UltraChart.Core.Layers;
using Infragistics.UltraChart.Core.Primitives;

namespace UltraChartBubbleChartLegend
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            DataTable dt = new DataTable();
            dt.Columns.Add("Label", typeof(string));
            dt.Columns.Add("X", typeof(double));
            dt.Columns.Add("Y", typeof(double));
            dt.Columns.Add("R", typeof(double));
            dt.Rows.Add("Test 1", 10, 20, 5);
            dt.Rows.Add("Test 2", 40, 10, 3);
            dt.Rows.Add("Test 3", 30, 30, 4);
            dt.Rows.Add("Test 4", 20, 30, 2);
            ultraChart1.DataSource = dt;


            this.ultraChart1.ChartType = ChartType.Composite;

            ChartArea area = new ChartArea();
            this.ultraChart1.CompositeChart.ChartAreas.Add(area);
            
            AxisItem axisY = new AxisItem();
            axisY.Extent = 40;
            axisY.DataType = AxisDataType.Numeric;
            axisY.Labels.ItemFormatString = "<DATA_VALUE:##.##>";
            axisY.OrientationType = AxisNumber.Y_Axis;
            axisY.LineColor = Color.Red;
            axisY.RangeType = AxisRangeType.Custom;
            axisY.RangeMin = 0;
            axisY.RangeMax = 50;
            area.Axes.Add(axisY);

            //Create X axis - time axis
            AxisItem axisX = new AxisItem();
            axisX.DataType = AxisDataType.Numeric;
            axisX.Extent = 100;
            axisX.Labels.ItemFormat = AxisItemLabelFormat.DataValue;
            axisX.OrientationType = AxisNumber.X_Axis;
            axisX.SetLabelAxisType = SetLabelAxisType.ContinuousData;
            axisX.Labels.Orientation = TextOrientation.VerticalLeftFacing;
            axisX.RangeType = AxisRangeType.Custom;
            axisX.RangeMin = 0;
            axisX.RangeMax = 50;
            area.Axes.Add(axisX);

            ChartLayerAppearance myColumnLayer = new ChartLayerAppearance();
            myColumnLayer.ChartType = ChartType.BubbleChart;
            myColumnLayer.ChartArea = area;

            ChartLayerAppearance myColumnLayer2 = new ChartLayerAppearance();
            myColumnLayer2.ChartType = ChartType.ScatterChart;
            myColumnLayer2.ChartArea = area;
            


            XYZSeries s1 = new XYZSeries();
            s1.Label = "test";
            s1.DataBind(dt, "X", "Y", "R", "Label");
            s1.Visible = true;
            s1.PEs.Add(new PaintElement(Color.Yellow));
            s1.PEs.Add(new PaintElement(Color.Red));
            s1.PEs.Add(new PaintElement(Color.Green));
            s1.PEs.Add(new PaintElement(Color.Pink));
            myColumnLayer.Series.Add(s1);
            myColumnLayer2.Series.Add(s1);
            ultraChart1.CompositeChart.Series.Add(s1);
            myColumnLayer.AxisX = axisX;
            myColumnLayer.AxisY = axisY;
            this.ultraChart1.CompositeChart.ChartLayers.Add(myColumnLayer);

            CompositeLegend myLegend = new CompositeLegend();
            myLegend.ChartLayers.Add(myColumnLayer2);
            
            myLegend.ChartLayers[0].LegendItem = LegendItemType.Point;
            myLegend.Bounds = new Rectangle(3, 83, 25, 15);
            myLegend.BoundsMeasureType = MeasureType.Percentage;
            myLegend.PE.ElementType = PaintElementType.Gradient;
            myLegend.PE.FillGradientStyle = GradientStyle.ForwardDiagonal;
            myLegend.PE.Fill = Color.CornflowerBlue;
            myLegend.PE.FillStopColor = Color.Transparent;
            myLegend.Border.CornerRadius = 10;
            myLegend.Border.Thickness = 1;

            ultraChart1.Tooltips.Format = TooltipStyle.LabelPlusDataValue;
            this.ultraChart1.CompositeChart.Legends.Add(myLegend);
            ultraChart1.Legend.Visible = true;
        }

        private void ultraChart1_FillSceneGraph(object sender, Infragistics.UltraChart.Shared.Events.FillSceneGraphEventArgs e)
        {
            foreach (Primitive item in e.SceneGraph)
            {
                Text pl = item as Text;
                if (pl != null)
                {
                    string temp = pl.GetTextString();
                    switch (temp)
                    {
                        case "Test 1":
                            pl.PE.Fill = Color.Yellow;
                            break;
                        case "Test 2":
                            pl.PE.Fill = Color.Red;
                            break;
                        case "Test 3":
                            pl.PE.Fill = Color.Green;
                            break;
                        case "Test 4":
                            pl.PE.Fill = Color.Pink;
                            break;
                    }
                }
            }
        }
    }
}
